if(!settings.multipleView) settings.batchView=false;
settings.tex="pdflatex";
defaultfilename="cj12-09-1";
if(settings.render < 0) settings.render=4;
settings.outformat="";
settings.inlineimage=true;
settings.embed=true;
settings.toolbar=false;
viewportmargin=(2,2);

import roundedpath;
usepackage("mathptmx");
defaultpen(TimesRoman());
usepackage("helvet", options="scaled");
void drawLabeledBox(real x, int y, int width, int height, string name){
draw(roundedpath(
(x, y)--(x+width, y)--(x+width, y+height)--(x, y+height)--cycle,
0.5));
label(name, (x + (width/2), y + (height/2)));
}

size(6.5cm);
defaultpen(fontsize(11));
void drawarrow(int x, real y1, real y2, string name, pen p=currentpen, real size=7){
draw((x,y1)--(x,y2), p, EndArrow(SimpleHead, size));
pair m=(x, (y1+y2)/2);
real l=0.2;
draw((m.x-l, m.y-l)--(m.x+l, m.y+l));
label(name, (m.x + l + 0.05, m.y), E);
}
drawLabeledBox(0, 0, 12, 2, "verifier");
drawLabeledBox(0, 5, 12, 2, "prover");
drawarrow(1, 2.1, 4.9, "$1$");
drawarrow(3, 4.9, 2.1, "$1$");
drawarrow(5, 2.1, 4.9, "$1$");
drawarrow(7, 4.9, 2.1, "$1$");
drawarrow(9, 2.1, 4.9, "$1$");
pen p=currentpen + 1;
drawarrow(11, 4.9, 2.1, "$\mathsf{poly}(n)$", p);
